<?php
/*
* TSA request
* params 
*             $inputMassage - String to timestamping
* $urlTSA 
*             $nonce
* $params - PROXY - using proxy "127.0.0.1:8080" 
			      TIMEOUT - in secunds
			      username,password - Login User/Password
* return TSA Response
*/
function TSA_request($inputMassage,$urlTSA="http://tsa.b-trust.org",$nonce='',$params=array()){
    $noncesize=8;
    $DEF_PARAMS=array('TIMEOUT'=>10,'PROXY'=>false);
    if (is_array($params)){    	
    	$params=array_merge($DEF_PARAMS, $params);
    } else{
    	$params=$DEF_PARAMS;
    }
	if(!extension_loaded('curl')) {
		dl('php_curl.' . PHP_SHLIB_SUFFIX);
	}
	if(!extension_loaded('curl')) {
		return false;
	}
		
   // $tsa_rq=pack("H*","3031020101301F300706052B0E03021A0414");
   // $tsa_rq.=sha1($inputMassage,true);    
    $tsa_rq=pack("H*","30430201013031300D060960864801650304020105000420");
    $tsa_rq.=hash('sha256',$inputMassage,true);   
    $tsa_rq.=pack("H*","02");
    if ($nonce==''){
        $nonce = ''; 

        while (strlen($nonce) < $noncesize) { 
          $nonce .= mt_rand(3,55); 
        } 
    $nonce=substr($nonce,0,$noncesize);
    }
    
    $tsa_rq.=trim(pack("i",$noncesize)).$nonce;
    $tsa_rq.=pack("H*","0101FF");  
  	writeToFile("ts_req.tsq", $tsa_rq);
  	$curl = curl_init();
  	////////////////////////////////////////////////////////////////
  	//Add authentication - DV - 08.01.2015 
    //Edit SB - 21.01.2020

  	if (array_key_exists('username',$params) ){
  		$header[] = "Authorization: Basic ".base64_encode($params['username'].":".$params['password']);       		
    }
  	///////////////////////////////////////////////////////////////
  	$header[] = "Content-Type: application/timestamp-query"; 
  	$header[] = "Content-Length: ".strlen($tsa_rq);
   	curl_setopt($curl, CURLOPT_URL, $urlTSA);
   	curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
   	curl_setopt($curl, CURLOPT_TIMEOUT, $params['TIMEOUT']);
   	curl_setopt($curl, CURLOPT_ENCODING, 'gzip,deflate');
   	curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
   	curl_setopt($curl, CURLOPT_POST, 1);
   	curl_setopt($curl, CURLOPT_POSTFIELDS, $tsa_rq); 
   	if ( $params['PROXY'])
		curl_setopt($curl, CURLOPT_PROXY,$params['PROXY']);
   
   	$TSA_rep = curl_exec($curl); // execute the curl command
   	$curl_info=curl_getinfo($curl);
   	curl_close($curl);
   if($curl_info['http_code']!=200) {
                     return false;
      }
      if($curl_info['size_download']<10) {
                     return false;
      }
   return $TSA_rep;
}
/*
* Verify TSA response
* params 
*             $tsaRsp - Timestamp response
*/
function verifyTSAResponse($tsaRsp){
	if(is_numeric(strpos($tsaRsp, "Operation Okay"))){	
		writeToFile("ts_rsp.tsr", $tsaRsp);	
		print "TSA response OK";
	} else 	
		print "TSA response not OK";
}
/*
* Write data to file
* params 
*             $filename - the name of the file, the path is alawys d:\temp
*             $data - data to be written
*/
function writeToFile($filename, $data){
	$file = $filename;		
	$fp = fopen($file, 'w');
	if($fp != false){
		fwrite($fp, $data);
		fclose($fp);
	} else 
		print "Error while writing TSA response to file<br>";		
}
//         
//$params=array('username'=>'{USERNAME}','password'=>'{PASSWORD}');
//      IP
// $params=array();
verifyTSAResponse(TSA_request("test","http://tsa.b-trust.org",'',$params));
?>
